geom_subr.sh revision 297612
1#!/bin/sh
2# $FreeBSD: stable/10/tests/sys/geom/class/geom_subr.sh 297612 2016-04-06 06:37:36Z ngie $
3
4devwait()
5{
6	while :; do
7		if [ -c /dev/${class}/${name} ]; then
8			return
9		fi
10		sleep 0.2
11	done
12}
13
14attach_md()
15{
16	local test_md
17
18	test_md=$(mdconfig -a "$@") || exit
19	echo $test_md >> $TEST_MDS_FILE || exit
20	echo $test_md
21}
22
23geom_test_cleanup()
24{
25	local test_md
26
27	if [ -f "$TEST_MDS_FILE" ]; then
28		while read test_md; do
29			# The "#" tells the TAP parser this is a comment
30			echo "# Removing test memory disk: $test_md"
31			mdconfig -d -u $test_md
32		done < $TEST_MDS_FILE
33	fi
34	rm -f "$TEST_MDS_FILE"
35}
36
37if [ $(id -u) -ne 0 ]; then
38	echo '1..0 # SKIP tests must be run as root'
39	exit 0
40fi
41# If the geom class isn't already loaded, try loading it.
42if ! kldstat -q -m g_${class}; then
43	if ! geom ${class} load; then
44		echo "1..0 # SKIP could not load module for geom class=${class}"
45		exit 0
46	fi
47fi
48
49# Need to keep track of the test md devices to avoid the scenario where a test
50# failing will cause the other tests to bomb out, or a test failing will leave
51# a large number of md(4) devices lingering around
52: ${TMPDIR=/tmp}
53export TMPDIR
54if ! TEST_MDS_FILE=$(mktemp ${TMPDIR}/test_mds.XXXXXX); then
55	echo 'Failed to create temporary file for tracking the test md(4) devices'
56	echo 'Bail out!'
57	exit 1
58fi
59